<?php
	//Inicialització i verificació de sessió
	INCLUDE 'inc/common.php';
	INCLUDE 'inc/seo.inc.php';
	
	$id="";
	$nom="";
	$fitxer="";

	//Llegir
	//========================================================================================================
	//Si tenim id llegim la informació desada a la bd
	if ( (isset($_REQUEST['sala'])) && ($_REQUEST['sala']!="") ){
		$id = round($_REQUEST['sala']);
		if ($id > 0) {
			//Connecta a la base de dades
			$db = &ADONewConnection('mysql');
			$db->connect(MYSQL_SERVER,MYSQL_USER,MYSQL_PSW,MYSQL_DB);
			if (!$db) die("Connection failed");

			// Per obtenir charset de connexió
			$charSet = @$db->GetAssoc('SHOW VARIABLES LIKE "character_set_client"');
			$GLOBALS['DBcharSet'] = $charSet['character_set_client'];

			//Les connexions les treballarem en utf8
			$charset_name = "utf8";
			$db->Execute(sprintf("SET NAMES '%s'", $charset_name));

			
			$sql = "SELECT s.*,a.nom as nom_sala,a.carpeta FROM sales AS s LEFT JOIN aules AS a ON a.id = s.id_aula WHERE s.id='".$id."'";
			$rs = $db->Execute($sql);

			if (!$rs->EOF) {				
				$nom     = $rs->fields['nom'];
				$fitxer  = $rs->fields['fitxer'];
				
				//Dades de l'aula que conté la sala
				$id_aula = $rs->fields['id_aula'];
				$nom_aula= $rs->fields['nom_sala'];
				$carpeta = $rs->fields['carpeta'];
			}else{
				//Intent de desat no vàlid: no existeix l'id que ens han passat
				$db->Close();
				header("Location: index.php");
			}
		}else{
			//Intent de desat no vàlid: intent de sqlinject
			$_SESSION['s_idusuari'] = "";
			$_SESSION['s_usuari'] = "";
			$_SESSION['s_contrasenya'] = "";
			$_SESSION['s_rol'] = "";
			$_SESSION['s_color'] = "";
			$_SESSION['s_idsala']="0";
			$_SESSION['s_fitxer_sala']="";
			$_SESSION['s_ultimmissatge']=0;
			header("Location: login.php");
		}
	}elseif ( (isset($_REQUEST['aula'])) && ($_REQUEST['aula']!="") ){
		$id_aula = round($_REQUEST['aula']);
		if ($id_aula > 0) {
			//Connecta a la base de dades
			$db = &ADONewConnection('mysql');
			$db->connect(MYSQL_SERVER,MYSQL_USER,MYSQL_PSW,MYSQL_DB);
			if (!$db) die("Connection failed");

			// Per obtenir charset de connexió
			$charSet = @$db->GetAssoc('SHOW VARIABLES LIKE "character_set_client"');
			$GLOBALS['DBcharSet'] = $charSet['character_set_client'];

			//Les connexions les treballarem en utf8
			$charset_name = "utf8";
			$db->Execute(sprintf("SET NAMES '%s'", $charset_name));

			$sql = "SELECT * FROM aules WHERE id='".$id_aula."'";			
			$rs = $db->Execute($sql);

			if (!$rs->EOF) {			
				$nom     = "";
				$fitxer  = "";
				
				//Dades de l'aula que conté la sala
				$id_aula = $rs->fields['id'];
				$nom_aula= $rs->fields['nom'];
				$carpeta = $rs->fields['carpeta'];
			}else{
				//Intent de nova creació no vàlid: no existeix l'id de l'aula que ens han passat
				$db->Close();
				header("Location: index.php");
			}
		}else{
			//Intent d'inserció no vàlid: intent de sqlinject
			$_SESSION['s_idusuari'] = "";
			$_SESSION['s_usuari'] = "";
			$_SESSION['s_contrasenya'] = "";
			$_SESSION['s_rol'] = "";
			$_SESSION['s_color'] = "";
			$_SESSION['s_idsala']="0";
			$_SESSION['s_fitxer_sala']="";
			$_SESSION['s_ultimmissatge']=0;
			header("Location: login.php");
		}
	}

	//Esborrar
	//========================================================================================================
	if ( (isset($_REQUEST['action'])) && ($_REQUEST['action']=="delete") ){
		//Connecta a la base de dades
		$db = &ADONewConnection('mysql');
		$db->connect(MYSQL_SERVER,MYSQL_USER,MYSQL_PSW,MYSQL_DB);
		if (!$db) die("Connection failed");

		// Per obtenir charset de connexió
		$charSet = @$db->GetAssoc('SHOW VARIABLES LIKE "character_set_client"');
		$GLOBALS['DBcharSet'] = $charSet['character_set_client'];

		//Les connexions les treballarem en utf8
		$charset_name = "utf8";
		$db->Execute(sprintf("SET NAMES '%s'", $charset_name));

		//Esborrem els usuaris connectats a la sala
		$sql = "DELETE FROM usuaris_connectats WHERE id_sala='".$id."'";
		$rs = $db->Execute($sql);

		//Esborrem la sala
		$sql = "DELETE FROM sales WHERE id='".$id."'";
		$rs = $db->Execute($sql);
		
		$db->Close();

		//Renombrem el fitxer amb una marca de temps
		$now = date("YmdHis");			
		rename("sales/".$carpeta."/".$fitxer.".log", "sales/".$carpeta."/".$now." ".$fitxer.".log");
		header("Location: index.php");
	//Desar !
	//========================================================================================================
	}else if (isset($_POST['nom'])) {
	
		//Si ens han passat un nom i és diferent a l'anterior si és que existia, el creem o l'actualitzem		
		if ($nom != $_POST['nom']) {
			
			$nom = $_POST['nom'];
			
			//Calcula el nom de fitxer formatant el nom
			$fitxer_nou = normalizeText($_POST['nom']);

			//El nou nom de fitxer ja existeix
			if (file_exists("sales/".$carpeta."/".$fitxer_nou.".log")) {
				$smarty->assign('error', 'Atenci&oacute;: el nom de fitxer obtingut ja existeix, provi amb un altre nom.');
			}else{
				//Connecta a la base de dades
				$db = &ADONewConnection('mysql');
				$db->connect(MYSQL_SERVER,MYSQL_USER,MYSQL_PSW,MYSQL_DB);
				if (!$db) die("Connection failed");

				// Per obtenir charset de connexió
				$charSet = @$db->GetAssoc('SHOW VARIABLES LIKE "character_set_client"');
				$GLOBALS['DBcharSet'] = $charSet['character_set_client'];

				//Les connexions les treballarem en utf8
				$charset_name = "utf8";
				$db->Execute(sprintf("SET NAMES '%s'", $charset_name));
				
				//Actualizació sala
				//-----------------------------------------------------------------------------------------
				
				if ($id > 0){
				
					$file     = "sales/".$carpeta."/".$fitxer.".log";
					$file_nou = "sales/".$carpeta."/".$fitxer_nou.".log";
					
					//Si encara no tenia un fitxer assignat, el creem
					if ($fitxer == "") {
						$fileHandle = fopen($file, 'w') or die("can't open file");
						file_put_contents($file, PHP_EOL, FILE_APPEND | LOCK_EX);
						fclose($fileHandle);						
					}else{
						//Si existeix l'anterior el renombrem
						if (file_exists($file)) {						
							rename($file, $file_nou);
						}else{ //si no la creem nova
							$fileHandle = fopen($file_nou, 'w') or die("can't open file");
							file_put_contents($file_nou, PHP_EOL, FILE_APPEND | LOCK_EX);
							fclose($fileHandle);						
						}
					}
					$fitxer = $fitxer_nou;
					
					//Actualizem les dades a la BD
					$sql = "UPDATE sales SET id_aula='".$id_aula."', nom='".$nom."', fitxer='".$fitxer."' WHERE id='".$id."'";
					$rs = $db->Execute($sql);
					$db->Close();
					header("Location: index.php");
					
				//Nova sala
				//-----------------------------------------------------------------------------------------
				}else{
					$fitxer = $fitxer_nou;
					
					//Si no existeix el fitxer, podem desar a la bd i crear el fitxer log
					$file = "sales/".$carpeta."/".$fitxer.".log";
					if (!file_exists($file)) {						
						$fileHandle = fopen($file, 'w') or die("can't open file");
						file_put_contents($file, PHP_EOL, FILE_APPEND | LOCK_EX);
						fclose($fileHandle);
					
						$sql = "INSERT INTO sales (id_aula, nom, fitxer) VALUES('".$id_aula."','".$nom."','".$fitxer."')";
						$rs = $db->Execute($sql);
						$db->Close();
						header("Location: index.php");
					
					}else{ //La fitxer ja existeix, informem de l'error i tornem a mostrar la informació
						$smarty->assign('error', 'Atenci&oacute;: el nom de fitxer obtingut ja exiteix, si us renombri-la.');
					}

				}				
				$db->Close();
			}				

		}else{
			$smarty->assign('error', 'Atenci&oacute;: escrigui un nom d\'sala vàlid.');
		}			
	}		

	$smarty->assign('rol_sessio', $_SESSION['s_rol']);
	
	$smarty->assign('id', $id);
	$smarty->assign('nom', $nom);
	$smarty->assign('id_aula', $id_aula);
	$smarty->assign('nom_aula', $nom_aula);
	
	$smarty->assign('menu', 'aules');
	$smarty->display('sala.tpl');

?>