<?php
	//Inicialització i verificació de sessió
	INCLUDE 'inc/common.php';
	
	//Només els superusuaris i els administradors poden gestionar els usuaris
	if (($_SESSION['s_rol']==1) || ($_SESSION['s_rol']==2)) {	
		
		$id="";
		$rol="";
		$usuari="";
		$email="";
		$contrasenya="";
		$color="";
		$dataalta="";
		
		//Connecta a la base de dades
		$db = &ADONewConnection('mysql');
		$db->connect(MYSQL_SERVER,MYSQL_USER,MYSQL_PSW,MYSQL_DB);
		if (!$db) die("Connection failed");

		// Per obtenir charset de connexió
		$charSet = @$db->GetAssoc('SHOW VARIABLES LIKE "character_set_client"');
		$GLOBALS['DBcharSet'] = $charSet['character_set_client'];

		//Les connexions les treballarem en utf8
		$charset_name = "utf8";
		$db->Execute(sprintf("SET NAMES '%s'", $charset_name));
		
		//Obté el llistat d'aules, que té accés l'usuari autenticat, per a la selecció dels permisos d'accés
		//Superusuari ho veu tot
		if ($_SESSION['s_rol'] == 1) {
			$sql = "SELECT * FROM aules ";
		}else{ //Administradors i usuaris
			$sql = "SELECT a.* FROM usuaris_aules as ua ";
			$sql.= "LEFT JOIN aules as a ON a.id=ua.id_aula ";
			$sql.= "WHERE ua.id_usuari=".$_SESSION['s_idusuari']." ";
		}
		$sql.= "ORDER BY nom";
		$rs = $db->Execute($sql);
		$aules = ($rs->EOF) ? array() : $rs->GetRows();
		
		//Llegir
		//========================================================================================================
		//Si tenim id llegim la informació desada a la bd
		if ( (isset($_REQUEST['id'])) && ($_REQUEST['id']!="") ){
			$id = round($_REQUEST['id']);
			if ($id > 0) {
								
				$sql = "SELECT * FROM usuaris WHERE id='".$id."'";
				$rs = $db->Execute($sql);

				if (!$rs->EOF) {				
					//$id=$rs->fields['id'];
					$rol=$rs->fields['rol'];
					$usuari=$rs->fields['usuari'];
					$email=$rs->fields['email'];
					$contrasenya=$rs->fields['contrasenya'];
					$color=$rs->fields['color'];
					$dataalta=$rs->fields['dataAlta'];

					//El superusuari no té assignació d'aules per què té control total sobre totes
					if ($rol!=1) {
						//Llistat de ids de aules assignades a l'usuari que estem editant
						$sql = "SELECT a.id,true FROM usuaris_aules as ua ";
						$sql.= "LEFT JOIN aules as a ON a.id=ua.id_aula ";
						$sql.= "WHERE ua.id_usuari=".$id." ";
						$sql.= "ORDER BY nom";
						$rs = $db->Execute($sql);
						$usuaris_aules = ($rs->EOF) ? array() : $rs->GetAssoc();			
						for ($i=0; $i < count($aules);$i++){ //Marca les aules que té assignades l'usuari que estem editant
							$aules[$i]['assign'] = (isset($usuaris_aules[$aules[$i]['id']])) ? 1 : 0;
						}
					}
					
				}else{
					//Intent de desat no vàlid: no existeix l'id que ens han passat
					$db->Close();
					header("Location: index.php");
				}
			}else{
				//Intent de desat no vàlid: intent de sqlinject
				$_SESSION['s_idusuari'] = "";
				$_SESSION['s_usuari'] = "";
				$_SESSION['s_contrasenya'] = "";
				$_SESSION['s_rol'] = "";
				$_SESSION['s_color'] = "";
				$_SESSION['s_idusuari']="0";
				$_SESSION['s_fitxer_usuari']="";
				$_SESSION['s_ultimmissatge']=0;
				$db->Close();
				header("Location: login.php");
			}
		}
		
		//Esborrar
		//========================================================================================================
		if ( (isset($_REQUEST['action'])) && ($_REQUEST['action']=="delete") && ($_SESSION['s_rol']==1)){
		
			//Esborrem l'usuari de la llista de connectats
			$sql = "DELETE FROM usuaris_connectats WHERE id_usuari='".$id."'";
			$rs = $db->Execute($sql);

			//Esborrem aules assignades
			$sql = "DELETE FROM usuaris_aules WHERE id_usuari='".$id."'";
			$rs = $db->Execute($sql);

			//Esborrem l'usuari
			$sql = "DELETE FROM usuaris WHERE id='".$id."'";
			$rs = $db->Execute($sql);			
			
			$db->Close();
			header("Location: usuaris.php");
			
		//Desar
		//========================================================================================================
		}elseif (isset($_POST['color'])) {
			//Si és el formulari d'edició del superusuari, capturem la informació inclosa
			if ($_SESSION['s_rol']==1) {
				$rol = $_POST['rol'];
				$email = $_POST['email'];
				$contrasenya = $_POST['contrasenya'];
			}
			$color = strtoupper($_POST['color']);

			//Verifiquem que sigui un correu electronic vàlid
			if (isValidEmail($email)) {
			
				$usuari=substr($email,0,strpos($email,'@'));

				//Verifiquem que sigui un color vàlid
				if(preg_match('/^[a-f0-9]{6}$/i', $color)) { //FF00FF

					//Actualizació usuari
					//-----------------------------------------------------------------------------------------		
					if ($id > 0){ //Si no tenim id assignat el creem nou si no l'actualitzem
						if ((strlen($contrasenya)==0) || (strlen($contrasenya)>=4)) {
							//Actualizem les dades a la BD
							
							$sql = "UPDATE usuaris SET ";
							$sql.= "rol='".$rol."', ";
							$sql.= "email='".$email."', ";
							$sql.= "usuari='".$usuari."', ";
							if ((strlen($contrasenya) > 0) && ($_SESSION['s_rol']==1)) $sql.= "contrasenya='".md5($contrasenya)."', ";
							$sql.= "color='".$color."', ";
							$sql.= "dataAlta=NOW() ";
							$sql.= "WHERE id='".$id."'";
							
							$rs = $db->Execute($sql);
														
							//Assignem els permisos sobre les aules
							//Esborrem els possibles afectats tenint en compte el nivell d'acces de l'usuari que ho esta gestionant
							//Només esborra les aules que pot gestionar l'usuari autenticat per a l'usuari que esta editant
							$sql = "DELETE FROM usuaris_aules WHERE id_aula IN (";
							if ($_SESSION['s_rol'] == 1) {
								$sql.= "SELECT id FROM aules";
							}else{ //Administradors i usuaris
								$sql.= "SELECT a.id FROM usuaris_aules as ua ";
								$sql.= "LEFT JOIN aules as a ON a.id=ua.id_aula ";
								$sql.= "WHERE ua.id_usuari=".$_SESSION['s_idusuari'];
							}
							$sql.= ") AND id_usuari=".$id;
							$rs = $db->Execute($sql);
							
							//TODO Verificar que les aules que ens venen per post siguin unicament aules on l'usuari registrat tingui permisos:
							//recollir en un array la selecció WHERE IN anterior
							//comprobar que cada un dels elements de la colecció d'aules del formulari esta inclós en aquest array
							
							//Afegeix permisos a les aules marcades al formulari
							if (isset($_POST['aules'])){
								foreach($_POST['aules'] as $id_aula_assignar){
									$db->Execute("INSERT INTO usuaris_aules SET id_usuari='".$id."', id_aula='".$id_aula_assignar."'");
								}
							}
							
							$db->Close();
							header("Location: usuaris.php");
						}else{
							$smarty->assign('error', 'Atenci&oacute;: la contrasenya ha de tindre un mínim de 4 car&agrave;cters.<br />Si voleu conservar l\'anterior deixeu-la en blanc.');
						}		
					//Nou usuari
					//-----------------------------------------------------------------------------------------
					}else{
					
						//Comtrobem que l'usuari no existeixi anteriorment
						$sql = "SELECT * FROM usuaris WHERE email='".$email."'";
						$rs = $db->Execute($sql);					
						if ($rs->EOF) {							
							if (strlen($contrasenya)>=4) {
								$contrasenya = md5($_POST['contrasenya']);
								$sql = "INSERT INTO usuaris (rol, email, usuari, contrasenya, color, dataAlta) VALUES('".$rol."','".$email."','".$usuari."','".$contrasenya."','".$color."',NOW())";
								$rs = $db->Execute($sql);
								
								$sql = "SELECT id FROM usuaris WHERE usuari='".$usuari."'";								
								$rs = $db->Execute($sql);
								if (!$rs->EOF) {
									$id = $rs->fields['id'];
								
									//Assignem els permisos sobre les aules
									//Esborrem els possibles afectats tenint en compte el nivell d'acces de l'usuari que ho esta gestionant
									//Només esborra les aules que pot gestionar l'usuari autenticat per a l'usuari que esta editant
									$sql = "DELETE FROM usuaris_aules WHERE id_aula IN (";
									if ($_SESSION['s_rol'] == 1) {
										$sql.= "SELECT id FROM aules";
									}else{ //Administradors i usuaris
										$sql.= "SELECT a.id FROM usuaris_aules as ua ";
										$sql.= "LEFT JOIN aules as a ON a.id=ua.id_aula ";
										$sql.= "WHERE ua.id_usuari=".$_SESSION['s_idusuari'];
									}
									$sql.= ") AND id_usuari=".$id;
									$rs = $db->Execute($sql);
									
									//TODO Verificar que les aules que ens venen per post siguin unicament aules on l'usuari registrat tingui permisos:
									//recollir en un array la selecció WHERE IN anterior
									//comprobar que cada un dels elements de la colecció d'aules del formulari esta inclós en aquest array
									
									//Afegeix permisos a les aules marcades al formulari
									if (isset($_POST['aules'])){
										foreach($_POST['aules'] as $id_aula_assignar){
											$db->Execute("INSERT INTO usuaris_aules SET id_usuari='".$id."', id_aula='".$id_aula_assignar."'");
										}
									}
									$db->Close();
									header("Location: usuaris.php");
								}else{
									$smarty->assign('error', 'Atenci&oacute;: no s\'ha pogut desar l\'assignaci&oacute; d\'aules.');
								}
							}else{
								$smarty->assign('error', 'Atenci&oacute;: la contrasenya ha de tindre un mínim de 4 car&agrave;cters.');
							}					
						}else{
							$smarty->assign('error', 'Atenci&oacute;: ja existeix un usuari amb aquest correu electr&ograve;nic.');
						}

					}
						
				}else{
					$smarty->assign('error', 'Atenci&oacute;: el color no segueix la forma hexadecimal');
				}
			}else{
				$smarty->assign('error', 'Atenci&oacute;: l\'adreça de correu electr&ograve;nic no &eacute;s correcta.');
			}
		}
		$db->Close();

		$smarty->assign('rol_sessio', $_SESSION['s_rol']);
		
		$smarty->assign('id', $id);
		$smarty->assign('rol', $rol);
		$smarty->assign('usuari', $usuari);
		$smarty->assign('email', $email);
		$smarty->assign('color', $color);
		$smarty->assign('dataalta', $dataalta);
		
		$smarty->assign('aules', $aules);
		
		$smarty->assign('menu', 'usuaris');
		$smarty->display('usuari.tpl');
		
	}else{
		//Intent d'accés a pàgina sense permisos de superusuari o administrador
		$_SESSION['s_idusuari'] = "";
		$_SESSION['s_usuari'] = "";
		$_SESSION['s_contrasenya'] = "";
		$_SESSION['s_rol'] = "";
		$_SESSION['s_color'] = "";
		$_SESSION['s_idsala']="0";
		$_SESSION['s_fitxer_sala']="";
		$_SESSION['s_ultimmissatge']=0;
		
		header("Location: login.php");
	}
?>