<?php
	//Inicialització i verificació de sessió
	INCLUDE 'inc/common.php';
	INCLUDE 'inc/seo.inc.php';

	//Només els superusuaris poden gestionar les aules
	if ($_SESSION['s_rol']==1) {
	
		$id="";
		$nom="";
		$carpeta="";
		
		
		
		
		//Llegir
		//========================================================================================================
		//Si tenim id llegim la informació desada a la bd
		if ( (isset($_REQUEST['aula'])) && ($_REQUEST['aula']!="") ){
			$id = round($_REQUEST['aula']);
			if ($id > 0) {
				//Connecta a la base de dades
				$db = &ADONewConnection('mysql');
				$db->connect(MYSQL_SERVER,MYSQL_USER,MYSQL_PSW,MYSQL_DB);
				if (!$db) die("Connection failed");

				// Per obtenir charset de connexió
				$charSet = @$db->GetAssoc('SHOW VARIABLES LIKE "character_set_client"');
				$GLOBALS['DBcharSet'] = $charSet['character_set_client'];

				//Les connexions les treballarem en utf8
				$charset_name = "utf8";
				$db->Execute(sprintf("SET NAMES '%s'", $charset_name));

				
				$sql = "SELECT * FROM aules WHERE id='".$id."'";
				$rs = $db->Execute($sql);

				if (!$rs->EOF) {				
					$nom = $rs->fields['nom'];
					$carpeta = $rs->fields['carpeta'];
				}else{
					//Intent de desat no vàlid: no existeix l'id que ens han passat
					$db->Close();
					header("Location: index.php");
				}
			}else{
				//Intent de desat no vàlid: intent de sqlinject
				$_SESSION['s_idusuari'] = "";
				$_SESSION['s_usuari'] = "";
				$_SESSION['s_contrasenya'] = "";
				$_SESSION['s_rol'] = "";
				$_SESSION['s_color'] = "";
				$_SESSION['s_idsala']="0";
				$_SESSION['s_fitxer_sala']="";
				$_SESSION['s_ultimmissatge']=0;
				header("Location: login.php");
			}
		}

		
		
		
		//Esborrar
		//========================================================================================================
		if ( (isset($_REQUEST['action'])) && ($_REQUEST['action']=="delete") ){
			//Connecta a la base de dades
			$db = &ADONewConnection('mysql');
			$db->connect(MYSQL_SERVER,MYSQL_USER,MYSQL_PSW,MYSQL_DB);
			if (!$db) die("Connection failed");

			// Per obtenir charset de connexió
			$charSet = @$db->GetAssoc('SHOW VARIABLES LIKE "character_set_client"');
			$GLOBALS['DBcharSet'] = $charSet['character_set_client'];

			//Les connexions les treballarem en utf8
			$charset_name = "utf8";
			$db->Execute(sprintf("SET NAMES '%s'", $charset_name));

			$sql = "DELETE FROM aules WHERE id='".$id."'";
			$rs = $db->Execute($sql);

			//Esborrat de les sales contingudes
			$sql = "DELETE FROM sales WHERE id_sala='".$id."'";
			$rs = $db->Execute($sql);
			
			//Esborra els permisos d'accés a l'aula per part dels usuaris
			$sql = "DELETE FROM usuaris_aules WHERE id_aula='".$id."'";
			$rs = $db->Execute($sql);
						
			$db->Close();

			//Renombrem la carpeta amb una marca de temps
			$now = date("YmdHis");			
			rename("sales/".$carpeta, "sales/".$now." ".$carpeta);
			header("Location: index.php");
			
			
			
			
		//Desar
		//========================================================================================================
		}else if (isset($_POST['nom'])) {
		
			//Si ens han passat un nom i és diferent a l'anterior si és que existia, el creem o l'actualitzem		
			if ($nom != $_POST['nom']) {
				
				$nom = $_POST['nom'];
				
				//Calcula el nom de carpeta formatant el nom
				$carpeta_nova = normalizeText($_POST['nom']);
				
				//El nou nom de carpeta ja existeix
				if (is_dir("sales/".$carpeta_nova)) {
					$smarty->assign('error', 'Atenci&oacute;: el nom de carpeta obtingut ja existeix, provi amb un altre nom.');
				}else{
					//Connecta a la base de dades
					$db = &ADONewConnection('mysql');
					$db->connect(MYSQL_SERVER,MYSQL_USER,MYSQL_PSW,MYSQL_DB);
					if (!$db) die("Connection failed");

					// Per obtenir charset de connexió
					$charSet = @$db->GetAssoc('SHOW VARIABLES LIKE "character_set_client"');
					$GLOBALS['DBcharSet'] = $charSet['character_set_client'];

					//Les connexions les treballarem en utf8
					$charset_name = "utf8";
					$db->Execute(sprintf("SET NAMES '%s'", $charset_name));
					
					//Actualizació
					if ($id > 0){
						//Si encara no tenia carpeta assignada creem la nova
						if ($carpeta == "") {
							@mkdir("sales/".$carpeta_nova);
						}else{
							//Si existeix la anterior la renombrem
							if (is_dir("sales/".$carpeta)) {								
								rename("sales/".$carpeta, "sales/".$carpeta_nova);
							}else{ //si no la creem nova
								@mkdir("sales/".$carpeta_nova);
							}
						}
						$carpeta = $carpeta_nova;
						
						//Actualizem les dades a la BD
						$sql = "UPDATE aules SET nom='".$nom."', carpeta='".$carpeta."' WHERE id='".$id."'";
						$rs = $db->Execute($sql);
						$db->Close();
						header("Location: index.php");
						
					}else{ //Nova aula
						$carpeta = $carpeta_nova;
						
						//Si no existeix la carpeta podem desar a la bd i crear la carpeta
						if (!is_dir("sales/".$carpeta)) {
							@mkdir("sales");
							@mkdir("sales/".$carpeta);
							
							$sql = "INSERT INTO aules (nom, carpeta) VALUES('".$nom."','".$carpeta."')";
							$rs = $db->Execute($sql);
							$db->Close();
							header("Location: index.php");
						
						}else{ //La carpeta ja existeix, informem de l'error i tornem a mostrar la informació
							$smarty->assign('error', 'Atenci&oacute;: el nom de carpeta obtingut ja exiteix, si us renombri-la.');
						}

					}				
					$db->Close();
				}				

			}else{
				$smarty->assign('error', 'Atenci&oacute;: escrigui un nom d\'aula vàlid.');
			}			
		}		
		
		
		
		//Pàgina del formulari
		//========================================================================================================
		$smarty->assign('rol_sessio', $_SESSION['s_rol']);

		$smarty->assign('id', $id);
		$smarty->assign('nom', $nom);
		$smarty->assign('menu', 'aules');
		$smarty->display('aula.tpl');
				
	}else{
		//Intent d'accés a pàgina sense permisos de superusuari
		$_SESSION['s_idusuari'] = "";
		$_SESSION['s_usuari'] = "";
		$_SESSION['s_contrasenya'] = "";
		$_SESSION['s_rol'] = "";
		$_SESSION['s_color'] = "";
		$_SESSION['s_idsala']="0";
		$_SESSION['s_fitxer_sala']="";
		$_SESSION['s_ultimmissatge']=0;
		
		header("Location: login.php");
	}
	
?>