<?php
	//Inicialització i verificació de sessió
	INCLUDE 'inc/common.php';

	//Connecta a la base de dades
	$db = &ADONewConnection('mysql');	
	$db->connect(MYSQL_SERVER,MYSQL_USER,MYSQL_PSW,MYSQL_DB);
	if (!$db) die("Connection failed");

	//Obté el llistat d'aules i sales que té accés l'usuari
	//Superusuari ho veu tot
	if ($_SESSION['s_rol'] == 1) {
		$sql = "SELECT a.id as id_aula, a.nom as nom_aula, s.id as id_sala, s.nom as nom_sala, s.fitxer FROM sales as s ";
		$sql.= "RIGHT JOIN aules as a ON a.id=s.id_aula ";
	}else{ //Administradors i usuaris
		$sql = "SELECT a.id as id_aula, a.nom as nom_aula, s.id as id_sala, s.nom as nom_sala, s.fitxer FROM usuaris_aules as ua ";
		$sql.= "LEFT JOIN aules as a ON a.id=ua.id_aula ";
		$sql.= "LEFT JOIN sales as s ON s.id_aula=ua.id_aula ";
		$sql.= "WHERE ua.id_usuari=".$_SESSION['s_idusuari']." ";
	}
	$sql.= "ORDER BY nom_aula, nom_sala";
	$rs = $db->Execute($sql);
	
	$aules = ($rs->EOF) ? array() : $rs->GetRows();
	for ($i=0; $i < count($aules);$i++){
		$aules[$i]['nom_aula'] = htmlentities($aules[$i]['nom_aula']);
		$aules[$i]['nom_sala'] = htmlentities($aules[$i]['nom_sala']);
	}

	//Desconnecta l'usuari de qualsevol sala anterior
	$sql = "DELETE FROM usuaris_connectats WHERE id_usuari=".$_SESSION['s_idusuari'];	
	$rs = $db->Execute($sql);
	$_SESSION['s_idsala']="0";
	$_SESSION['s_fitxer_sala']="";
	$_SESSION['s_ultimmissatge']=0;
	
	$db->Close();
	
	//Mostra la pàgina amb el llistat d'aules i sales
	$smarty->assign('menu', 'aules');
	$smarty->assign('aules', $aules);
	$smarty->assign('rol_sessio', $_SESSION['s_rol']);
	$smarty->display('aulessales.tpl');
?>