<?php
	//Gestor d'usuaris per als superusuaris i administradors d'aules
	// Superusuari:   Control total
	// Administrador: Assigna usuaris amb perfil 'usuari' a les aules que gestiona aquest administrador

	//Inicialització i verificació de sessió
	INCLUDE 'inc/common.php';

	//Només els superusuaris i els administradors poden gestionar els usuaris
	if (($_SESSION['s_rol']==1) || ($_SESSION['s_rol']==2)) {	
		//Connecta a la base de dades
		$db = &ADONewConnection('mysql');	
		$db->connect(MYSQL_SERVER,MYSQL_USER,MYSQL_PSW,MYSQL_DB);
		if (!$db) die("Connection failed");

		//Obté el llistat d'usuaris ordenats per rol i usuari
		$sql = "SELECT * FROM usuaris ";
		if ($_SESSION['s_rol']!=1) $sql.= "WHERE rol=0 ";		
		$sql.= "ORDER BY rol, usuari";
		$rs = $db->Execute($sql);
		
		$usuaris = ($rs->EOF) ? array() : $rs->GetRows();

		//Desconnecta l'usuari de qualsevol sala anterior
		$sql = "DELETE FROM usuaris_connectats WHERE id_usuari=".$_SESSION['s_idusuari'];
		$rs = $db->Execute($sql);
		$_SESSION['s_idsala']="0";
		$_SESSION['s_fitxer_sala']="";
		$_SESSION['s_ultimmissatge']=0;
		
		$db->Close();
		
		//Mostra la pàgina amb el llistat d'usuaris i sales
		$smarty->assign('menu', 'usuaris');
		$smarty->assign('usuaris', $usuaris);
		$smarty->assign('rol_sessio', $_SESSION['s_rol']);
		$smarty->display('usuaris.tpl');

	}else{
		//Intent d'accés a pàgina sense permisos de superusuari o administrador
		$_SESSION['s_idusuari'] = "";
		$_SESSION['s_usuari'] = "";
		$_SESSION['s_contrasenya'] = "";
		$_SESSION['s_rol'] = "";
		$_SESSION['s_color'] = "";
		$_SESSION['s_idsala']="0";
		$_SESSION['s_fitxer_sala']="";
		$_SESSION['s_ultimmissatge']=0;
		
		header("Location: login.php");
	}
?>