<?php
	//Inicialització i verificació de sessió
	INCLUDE 'inc/common.php';

	//Connecta a la base de dades
	$db = &ADONewConnection('mysql');	
	$db->connect(MYSQL_SERVER,MYSQL_USER,MYSQL_PSW,MYSQL_DB);
	if (!$db) die("Connection failed");

	$id_sala = round($_GET['sala']); //Força que sigui un número prevenint sql inject
	if ($id_sala == 0) header("Location: index.php"); //Redirecciona al intentar accedir a una sala erronia
	
	//Es verifica que l'usuari tingui permisos d'accés a la sala
	//Superusuari ho veu tot
	if ($_SESSION['s_rol'] == 1) {
		$sql = "SELECT a.id as id_aula, a.nom as nom_aula, a.carpeta, s.id as id_sala, s.nom as nom_sala, s.fitxer FROM sales as s ";
		$sql.= "LEFT JOIN aules as a ON a.id=s.id_aula ";
		$sql.= "WHERE s.id=".$id_sala." ";
	}else{ //Administradors i usuaris
		$sql = "SELECT a.id as id_aula, a.nom as nom_aula, a.carpeta, s.id as id_sala, s.nom as nom_sala, s.fitxer FROM usuaris_aules as ua ";
		$sql.= "LEFT JOIN aules as a ON a.id=ua.id_aula ";
		$sql.= "LEFT JOIN sales as s ON s.id_aula=ua.id_aula ";
		$sql.= "WHERE ua.id_usuari=".$_SESSION['s_idusuari']." ";
		$sql.= "AND s.id=".$id_sala." ";
	}
	$rs = $db->Execute($sql);
	
	//Intent d'accés a sala inexistent o sense permisos
	if ($rs->EOF) {
		$db->Close();
		header("Location: index.php"); //Es redirecciona a la pàgina principal
		
	//Accés correcte
	}else{	
		//Assignem a la sessió la sala actual de conversa
		$_SESSION['s_idsala']=$rs->fields['id_sala'];
		$_SESSION['s_fitxer_sala']=$rs->fields['carpeta']."/".$rs->fields['fitxer'].".log";
		$_SESSION['s_ultimmissatge']=0;

		//Si no existeix el fitxer de la sala, el generem
		$file = "sales/".$_SESSION['s_fitxer_sala'];
		if (!file_exists($file)) {
			@mkdir("sales");
			@mkdir("sales/".$carpeta);
			$fileHandle = fopen($file, 'w') or die("can't open file");
			file_put_contents($file, PHP_EOL, FILE_APPEND | LOCK_EX);
			fclose($fileHandle);
		}
		
		$smarty->assign('id_sala',$_SESSION['s_idsala']);
		$smarty->assign('sala',htmlentities($rs->fields['nom_sala']));
		$smarty->assign('username',$_SESSION['s_usuari']);
		$smarty->assign('password','');	
		
		//Desconnecta l'usuari de qualsevol sala anterior
		$sql = "DELETE FROM usuaris_connectats WHERE id_usuari=".$_SESSION['s_idusuari'];	
		$rs = $db->Execute($sql);

		//Marca l'usuari com a connectat a la sala
		$sql = "INSERT INTO usuaris_connectats (id_usuari, id_sala, ultim_acces) VALUES (".$_SESSION['s_idusuari'].", ".$id_sala.", NOW())";
		$rs = $db->Execute($sql);
	
		$db->Close();
		
		//Mostra la pantalla de xat
		$smarty->display('xat.tpl');
	}	

?>